
-record(handler, { name, module, class, group, config, state}).
-record(cx,      { handlers, actions, req, module, lang, path, session, formatter=false, params, form, state=[] }).

-define(CTX, (erlang:get(context))).
-define(REQ, (erlang:get(context))#cx.req).


% IO protocol

-record(io,      { eval, data }).
-record(bin,     { data }).


% Client/Server protocol

-record(client,  { data }).
-record(server,  { data }).


% Nitrogen Protocol

-record(pickle,  { source, pickled, args }).
-record(flush,   { data }).
-record(direct,  { data }).
-record(ev,      { module, msg, trigger, name }).


% File Transfer Protocol

-record(ftp,     { id, sid, filename, meta, other1 = <<"">>, other2 = <<"">>, other3 = <<"">>, 'size', offset, block, data, status }).


% HTTP

-record(http,    { url, method, body, headers = [] }).
